<?php
// +-----------------------------------------------------------------------+
// | Mod Name : secureImages                                               |
// | Mod Version : 0.4                                                     |
// | Mod Orignal author: acp <iacp@free.fr>                                |
// | Mod description : see install files                                   |
// |                                                                       |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

function secureImages_htaccess_creation($simulate = FALSE) {
  if (!defined('PHPWG_ROOT_PATH'))
  {
    die('Hacking attempt!');
  }

  $opts['category_id'] = '';
  $opts['recursive'] = true;

  if (isset($_POST['cat']))
  {
    $opts['category_id'] = $_POST['cat'];
    // recursive ?
    if (!isset($_POST['subcats-included']) or $_POST['subcats-included'] != 1)
    {
      $opts['recursive'] = false;
    }
  }
  //  $start = get_moment();
  if (!isset($site_id))
    $site_id = 1;

  // filling $cat_ids : all categories required
  $cat_ids = array();

  $query = '
    SELECT id
      FROM '.CATEGORIES_TABLE.'
      WHERE site_id = '.$site_id.'
      AND dir IS NOT NULL';
  if (is_numeric($opts['category_id']))
  {
    if ($opts['recursive'])
    {
      $query.= '
        AND uppercats REGEXP \'(^|,)'.$opts['category_id'].'(,|$)\'
        ';
    }
    else
    {
      $query.= '
        AND id = '.$opts['category_id'].'
        ';
    }
  }
  $query.= '
    ;';
  $result = pwg_query($query);
  while ($row = mysql_fetch_array($result))
  {
    array_push($cat_ids, $row['id']);
  }

  if (count($cat_ids) == 0)
  {
    break;
  }

  $files = array();

  $query = '
    SELECT images.id, path, storage_category_id, GROUP_CONCAT(DISTINCT status) AS status
      FROM '.IMAGES_TABLE.' AS images
        JOIN '.IMAGE_CATEGORY_TABLE.' AS image_category
          ON images.id = image_category.image_id 
        JOIN '.CATEGORIES_TABLE.' AS categories
          ON image_category.category_id = categories.id 
      WHERE images.storage_category_id IN ('.implode(',', $cat_ids).')
      GROUP BY images.id
      ORDER BY storage_category_id ASC;';

  $result = pwg_query($query);

  unset($last_physical_category);
  $return = array('infos' => array(), 'errors' => array());

  while ($row = mysql_fetch_array($result)) {
    if (!isset($last_physical_category) || $last_physical_category !== $row['storage_category_id']) {
      // We are in another category (or we just started)
      if (isset($file))
        writeAllHtaccessFiles(dirname($file), $public, $simulate, $return);

      $file = preg_replace('|(\.\/)+|',
                          './',
                          PHPWG_ROOT_PATH .
                            dirname($row['path']) .
                            '/.htaccess'
                         );

      $public = array();
      $last_physical_category = $row['storage_category_id'];
    }

    if (strstr($row['status'], 'public') !== FALSE) {
      if (!isset($public))
        $public = array();
      array_push($public, basename($row['path']));
    }
  }
  if (isset($file) && isset($public))
    writeAllHtaccessFiles(dirname($file), $public, $simulate, $return);

  return $return;
}

function writeAllHtaccessFiles( $dir, $publicImages, $simulate, &$return ) {
  writeHtaccessFile($dir.'/.htaccess', $publicImages, $simulate, $return);
  writeHtaccessFile($dir.'/thumbnail/.htaccess', $publicImages, $simulate, $return);
  if (file_exists($dir.'/pwg_high'))
    writeHtaccessFile($dir.'/pwg_high/.htaccess', $publicImages, $simulate, $return);
}

function writeHtaccessFile( $file, $publicImages, $simulate, &$return ) {

  if (!is_writable_extended($file)) {
    array_push(
               $return['errors'],
               array('path' => $file,
                     'type' => 'SECUREIMAGES-HTACCESS-NOT-WRITEABLE'
                    )
              );
    return;
  }
  elseif ($simulate) {
    array_push(
               $return['infos'],
               array('path' => $file,
                     'info' => 'successfully created'
                    )
              );
    return;
  }

  $hdl = @fopen( $file, 'w' );
  
  if (!$hdl) {
    array_push(
               $return['errors'],
               array('path' => $file,
                     'type' => 'SECUREIMAGES-UNKNOWN'
                    )
              );
    return;
  }

  if (count($publicImages) > 0) {
    fwrite($hdl, '<FilesMatch "(' . 
      implode('|', $publicImages) .
      ')">' .
        "\nallow from all\n" .
        "</FilesMatch>\n\n"
        );
  }
  fwrite($hdl, 'deny from all');
  fclose($hdl);

  array_push(
             $return['infos'],
             array('path' => $file,
                   'info' => 'successfully created'
                  )
            );
}

function is_writable_extended($file) {
  if ( (!file_exists($file) and is_writable(dirname($file))) or
       is_writable($file)
     )
    return true;
}

?>
